#ifndef _TS_Main_H
#define _TS_Main_H

#include "Prefix.h"
#include "TS_Bus.h"
#include "OS_Library.h"

namespace EARTH {
namespace TS {
	class Main {
	public:
		Main()
		{
			mLibrary = NULL;

			::timeBeginPeriod(1);
		}

		~Main()
		{
			delete_(mLibrary);

			::timeEndPeriod(1);
		}

		void Run()
		{
			::wprintf(L"Sample.exe o[W 1.0\n");

			_ASSERTE(mLibrary == NULL);
			mLibrary = new OS::Library();

			PT::Bus::NewBusFunction function = mLibrary->Function();
			if (function == NULL) {
				::wprintf(L"SDK_EARTHSOFT_PT1.dll ǂݍ߂܂łB\n");
				return;
			}

			TS::Bus *bus = new Bus();
			bus->Run(function);
			delete_(bus);

			return;
		}

	protected:
		OS::Library *mLibrary;
	};
}
}

#endif
