#ifndef _TS_Stream_H
#define _TS_Stream_H

#include "Prefix.h"
#include "EARTH_PT.h"
#include "OS_File.h"
#include "OS_Memory.h"

namespace EARTH {
namespace TS {
	class Stream {
	public:
		Stream(uint tuner, wchar_t isdb)
		{
			Reset();

			mMemory = NULL;
			mMemoryPtr = NULL;

			mFile = NULL;

			// FILE_FLAG_NO_BUFFERING w肵Ă邽߁A݃TCYZN^TCY̔{ɂ邱ƂKvB
			// ܂A݃TCY TS pPbg̃TCY(PACKET_SIZE) ̔{ł邱Ƃ]܂B
			// ŃZN^TCY 4096 oCgƂƁA݃TCY 4096  PACKET_SIZE ̍ŏ{
			// ł 4096*47 ƂȂB

			mMemory = new OS::Memory(PAGE_COUNT);
			mMemoryPtr = static_cast<byte *>(mMemory->Ptr());

			wchar_t filename[MAX_PATH];
			::swprintf_s(filename, MAX_PATH, L"Tuner%d ISDB-%c.ts", tuner, isdb);

			_ASSERTE(mFile == NULL);
			mFile = new OS::File();
			mFile->Open(filename);
		}

		~Stream()
		{
			if (mFile) {
				mFile->Close();
				delete_(mFile);
			}

			delete_(mMemory);
		}

		void MicroPacket(uint packet)
		{
//			uint packetId      = BIT_SHIFT_MASK(packet, 29,  3);
			uint packetCounter = BIT_SHIFT_MASK(packet, 26,  3);
			uint packetStart   = BIT_SHIFT_MASK(packet, 25,  1);
//			uint packetError   = BIT_SHIFT_MASK(packet, 24,  1);
			uint packetData    = BIT_SHIFT_MASK(packet,  0, 24);

			// JE^lmF
			uint count = BIT_SHIFT_MASK(mCount, 0, 3);
			mCount++;

//			if (mCount < 100) {
//				wprintf(L"%d %d %06x\n", packetCounter, packetStart, packetData);
//			}

			if (packetCounter != count) {
				::wprintf(L"JE^lُłB\n");
			}

			// pPbgJnʒutOmF
			if (packetStart) {
				if (BIT_SHIFT_MASK(packetData, 15, 1)) {
					//::wprintf(L"[h\ŒȂG[܂B\n");
				} else {
					// oCgmF
					if (BIT_SHIFT_MASK(packetData, 16, 8) != 0x47) {
						::wprintf(L"pPbg̐擪oCg 0x47 ɂȂĂ܂B\n");
					}
				}

				if (mPacketOffset != 0) {
					::wprintf(L"ÕpPbg܂łB\n");
				}
				mPacketOffset = 0;
			}

			// f[^Rs[
			for (uint i=0; i<3; i++) {
				if (mPacketOffset < PACKET_SIZE) {
					mMemoryPtr[PACKET_SIZE*mPacketCount + mPacketOffset] = BIT_SHIFT_MASK(packetData, 8*(2-i), 8);
					mPacketOffset++;
				}
			}

			if (PACKET_SIZE <= mPacketOffset) {
				// ЂƂ̃pPbg
				mPacketOffset = 0;

				if (OS::Memory::PAGE_SIZE*PAGE_COUNT/PACKET_SIZE <= ++mPacketCount) {
					mPacketCount = 0;
					mFile->Write(mMemoryPtr, OS::Memory::PAGE_SIZE*PAGE_COUNT);
				}
			}
		}

		void Reset()
		{
			mCount = 0;

			mPacketCount = 0;
			mPacketOffset = 0;
		}

	protected:
		enum {
			PAGE_COUNT = 47,
			PACKET_SIZE = 188
		};

		OS::Memory *mMemory;
		byte *mMemoryPtr;

		OS::File *mFile;

		uint mCount;

		uint mPacketCount;
		uint mPacketOffset;
	};
}
}

#endif
